/*
 * definitions for sync timers
 */

struct fma_sync_timer {
  void (*st_callback)(void *);		/* user's callback */
  void *st_arg;				/* argument for callback */
  int st_timeout;			/* timeout value */

  int st_cancelled;			/* true if cancelled while awaiting 
					   sync packet send */

  struct lf_event *st_timer;		/* our timer */
};

struct fma_sync_timer *fma_sync_timer_setup(int nic_id, int port,
  void (*callback)(void *), void *arg, int timeout);
void fma_sync_timer_cancel(struct fma_sync_timer *stp);
struct fma_sync_timer *fma_myri_raw_send_with_timer(int nic_id, int port,
    void *route, int route_len, void *txbuf, int txlen,
    void (*callback_rtn)(void *), void *context, int timer);
